Loading...
Searching...
No Matches
BALL::QSAR::LDAModel Class Reference

`#include <BALL/QSAR/ldaModel.h>`

Inheritance diagram for BALL::QSAR::LDAModel:

## Public Member Functions

Constructors and Destructors
| LDAModel (const QSARData &q)
| ~LDAModel ()
Accessors
void | train ()
Eigen::VectorXd | predict (const vector< double > &substance, bool transform=1)
void | setParameters (vector< double > &v)
vector< double > | getParameters () const
void | saveToFile (string filename)
void | readFromFile (string filename)
Public Member Functions inherited from BALL::QSAR::ClassificationModel
| ClassificationModel (const QSARData &q)
| ~ClassificationModel ()
virtual void | operator= (ClassificationModel &m)
std::vector< int > | getClassLabels ()
Public Member Functions inherited from BALL::QSAR::Model
| Model (const QSARData &q)
virtual | ~Model ()
virtual void | operator= (const Model &m)
void | copyData (const Model &m)
void | copyDescriptorIDs (const Model &m)
void | readTrainingData ()
void | deleteDescriptorIDs ()
virtual bool | optimizeParameters (int, int)
bool | optimizeParameters (int k)
virtual double | calculateStdErr ()
std::multiset< unsigned int > * | getDescriptorIDs ()
void | setDataSource (const QSARData *q)
const Eigen::MatrixXd * | getDescriptorMatrix ()
const vector< string > * | getSubstanceNames ()
const vector< string > * | getDescriptorNames ()
const Eigen::MatrixXd | getDescriptorTransformations ()
const Eigen::MatrixXd | getYTransformations ()
const Eigen::MatrixXd * | getY ()
void | setDescriptorIDs (const std::multiset< unsigned int > &sl)
const string * | getType ()
void | getUnnormalizedFeatureValue (int compound, int feature, double &return_value)
void | getUnnormalizedResponseValue (int compound, int response, double &return_value)

## Additional Inherited Members

ClassificationValidation * | validation
const QSARData * | data
Validation * | model_val
Protected Member Functions inherited from BALL::QSAR::ClassificationModel
void | readClassInformationFromFile (std::ifstream &input, int no_classes)
void | saveClassInformationToFile (std::ofstream &out)
void | readLabels ()
void | equalSpaceDiscretization (unsigned int bins, Eigen::MatrixXd &discretization_information)
void | equalSpaceDiscretizationTestData (Eigen::VectorXd &compound, unsigned int bins, const Eigen::MatrixXd &discretization_information)
Protected Member Functions inherited from BALL::QSAR::Model
void | readMatrix (Eigen::MatrixXd &mat, std::ifstream &in, unsigned int lines, unsigned int col)
void | readVector (Eigen::RowVectorXd &vec, std::ifstream &in, unsigned int no_cells, bool column_vector)
void | readModelParametersFromFile (std::ifstream &in)
void | saveModelParametersToFile (std::ofstream &out)
virtual void | saveDescriptorInformationToFile (std::ofstream &out)
virtual void | readDescriptorInformationFromFile (std::ifstream &in, int no_descriptors, bool transformation)
void | readResponseTransformationFromFile (std::ifstream &in, int no_y)
void | saveResponseTransformationToFile (std::ofstream &out)
Eigen::VectorXd | getSubstanceVector (const vector< double > &substance, bool transform)
Eigen::VectorXd | getSubstanceVector (const Eigen::VectorXd &substance, bool transform)
void | backTransformPrediction (Eigen::VectorXd &pred)
void | addLambda (Eigen::MatrixXd &matrix, double &lambda)
void | readDescriptorInformation ()
std::vector< int > | labels_
std::vector< int > | no_substances_
void(ClassificationModel::* | discretizeFeatures )(unsigned int bins, Eigen::MatrixXd &discretization_information)
void(ClassificationModel::* | discretizeTestDataFeatures )(Eigen::VectorXd &compound, unsigned int bins, const Eigen::MatrixXd &discretization_information)
int | default_no_opt_steps_
Eigen::MatrixXd | descriptor_matrix_
vector< string > | substance_names_
vector< string > | descriptor_names_
Eigen::MatrixXd | descriptor_transformations_
Eigen::MatrixXd | y_transformations_
Eigen::MatrixXd | Y_
String | type_
std::multiset< unsigned int > | descriptor_IDs_

## Detailed Description

class for support vector classification

Definition at line 21 of file ldaModel.h.

## Constructor & Destructor Documentation

## LDAModel()

BALL::QSAR::LDAModel::LDAModel | ( | const QSARData & | q | ) |

## ~LDAModel()

BALL::QSAR::LDAModel::~LDAModel | ( |  | ) |

## Member Function Documentation

## getParameters()

vector< double > BALL::QSAR::LDAModel::getParameters | ( |  | ) | const

virtual

Reimplemented from BALL::QSAR::Model.

## predict()

Eigen::VectorXd BALL::QSAR::LDAModel::predict | ( | const vector< double > & | substance,
|  | bool | transform = 1 )

virtual

Predicts the activities of a given substance

Parameters

  substance | the substance which activity is to be predicted in form of a vecor containing the values for all descriptors (if neccessary, relevant descriptors will be selected automatically)

  transform

  determines whether the values for each descriptor of the given substance should be transformed before prediction of activity.
  If (transform==1): each descriptor value is transformed according to the centering of the respective column of QSARData.descriptor_matrix used to train this model.
  If the substance to be predicted is part of the same input data (e.g. same SD-file) as the training data (as is the case during cross validation), transform should therefore be set to 0.

Returns
  a RowVector containing one value for each predicted activity

Implements BALL::QSAR::Model.

## readFromFile()

void BALL::QSAR::LDAModel::readFromFile | ( | string | filename | ) |

virtual

reconstruct a saved Model from a file

Implements BALL::QSAR::Model.

## saveToFile()

void BALL::QSAR::LDAModel::saveToFile | ( | string | filename | ) |

virtual

save Model to a file

Implements BALL::QSAR::Model.

## setParameters()

void BALL::QSAR::LDAModel::setParameters | ( | vector< double > & |  | ) |

virtual

sets the model parameters according to the given values.

Reimplemented from BALL::QSAR::Model.

## train()

void BALL::QSAR::LDAModel::train | ( |  | ) |

virtual

Starts training the model.

Implements BALL::QSAR::Model.